package dev.shadowsoffire.apotheosis.ench.enchantments.masterwork;

import net.minecraft.world.entity.projectile.AbstractArrow;
import net.minecraft.world.entity.projectile.Projectile;
import net.minecraft.nbt.Tag;
import net.minecraft.world.item.CrossbowItem;
import dev.shadowsoffire.apotheosis.ench.Ench;
import dev.shadowsoffire.apotheosis.Apotheosis;
import net.minecraft.world.item.ItemStack;
import net.minecraft.ChatFormatting;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.network.chat.Component;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.world.item.enchantment.EnchantmentCategory;
import net.minecraft.nbt.ListTag;
import net.minecraft.world.item.enchantment.Enchantment;

public class CrescendoEnchant extends Enchantment
{
    private static ThreadLocal<ListTag> nbt;
    
    public CrescendoEnchant() {
        super(Enchantment.Rarity.VERY_RARE, EnchantmentCategory.CROSSBOW, new EquipmentSlot[] { EquipmentSlot.MAINHAND });
    }
    
    public int m_6586_() {
        return 5;
    }
    
    public int m_6183_(final int level) {
        return 55 + (level - 1) * 30;
    }
    
    public int m_6175_(final int level) {
        return 200;
    }
    
    public Component m_44700_(final int level) {
        return (Component)((MutableComponent)super.m_44700_(level)).m_130940_(ChatFormatting.DARK_GREEN);
    }
    
    public static void preArrowFired(final ItemStack crossbow) {
        if (!Apotheosis.enableEnch) {
            return;
        }
        final int level = crossbow.getEnchantmentLevel((Enchantment)Ench.Enchantments.CRESCENDO.get());
        if (level > 0) {
            CrescendoEnchant.nbt.set(crossbow.m_41783_().m_128437_("ChargedProjectiles", 10).m_6426_());
        }
    }
    
    public static void onArrowFired(final ItemStack crossbow) {
        if (!Apotheosis.enableEnch) {
            return;
        }
        final int level = crossbow.getEnchantmentLevel((Enchantment)Ench.Enchantments.CRESCENDO.get());
        if (level > 0 && CrescendoEnchant.nbt.get() != null) {
            final int shots = crossbow.m_41783_().m_128451_("shots");
            if (shots < level) {
                crossbow.m_41783_().m_128405_("shots", shots + 1);
                CrossbowItem.m_40884_(crossbow, true);
                crossbow.m_41783_().m_128365_("ChargedProjectiles", (Tag)CrescendoEnchant.nbt.get());
            }
            else {
                crossbow.m_41783_().m_128473_("shots");
            }
            CrescendoEnchant.nbt.set(null);
        }
    }
    
    public static void markGeneratedArrows(final Projectile arrow, final ItemStack crossbow) {
        if (!Apotheosis.enableEnch) {
            return;
        }
        if (crossbow.m_41783_().m_128451_("shots") > 0 && arrow instanceof AbstractArrow) {
            final AbstractArrow arr = (AbstractArrow)arrow;
            arr.f_36705_ = AbstractArrow.Pickup.CREATIVE_ONLY;
        }
    }
    
    static {
        CrescendoEnchant.nbt = new ThreadLocal<ListTag>();
    }
}
